package de.intevation.flys.artifacts.math.fitting;

public class LogLinear
extends      Function
{
    public LogLinear() {
        super(
            "log-linear",
            "W(Q) = a*ln(m*Q + b)",
            new String [] { "a", "m", "b" });
    }

    @Override
    public double value(double x, double [] parameters) {
        return parameters[0]*Math.log(parameters[1]*x + parameters[2]);
    }

    @Override
    public double [] gradient(double x, double [] parameters) {
        double l = parameters[1]*x + parameters[2];
        return new double [] {
            Math.log(l),
            parameters[0]*x/l,
            parameters[0]/l
        };
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
